#!/usr/bin/env python
# Copyright (c) 2009-2010 ActiveState Software Inc.
# See the file LICENSE.txt for licensing information.

# Stub module that is loaded when a database adaptor
# can't be loaded

#---- Global

adaptorName = None

class OperationalError(Exception):
    pass

class DatabaseError(Exception):
    pass

class IntegrityError(Exception):
    pass

def connect(*args):
    if adaptorName:
        raise NotImplementedError("Database adaptor '%s' not loaded" % adaptorName)
    else:
        raise NotImplementedError("Database adaptor not loaded")

loaded = False
