/* Copyright (c) 2004-2009 ActiveState Software Inc.
   See the file LICENSE.txt for licensing information. */

function onloadDomviewPrefOverlay() {
    // First time we need to create the global pref, so that the general
    // pref manager doesn't get confused when it goes to save the changed prefs.
    
    var gprefs = parent.hPrefWindow.prefset;
    if (!gprefs) {
        gprefs = Components.classes["@activestate.com/koPrefService;1"].getService(Components.interfaces.koIPrefService).prefs;
    }
    if (!gprefs.hasPref("DOMViewer_enabled")) {
        gprefs.setBooleanPref("DOMViewer_enabled", true);
    }
    var disableDOMViewer = !_getMarkupLanguage();
    var DOMViewer_enabled_field = window.document.getElementById("DOMViewer_enabled");
    var view = parent.view;
    var prefset = view ? view.prefs : null;
    if (disableDOMViewer || !prefset) {
        DOMViewer_enabled_field.checked = false;
        DOMViewer_enabled_field.disabled = true;
    } else {
        DOMViewer_enabled_field.checked = prefset.getBooleanPref("DOMViewer_enabled");
        DOMViewer_enabled_field.disabled = false;
    }
}

// From file-properties.p.xul.  Should be in a separate .js file.

function _getMarkupLanguage() {
    var domLanguages = ["XML", "HTML", "XHTML", "XSLT"];
    var langSvc = parent.view.document.languageObj;
    var found = domLanguages.indexOf(langSvc.name) >= 0 ? langSvc.name : null;
    if (!found) {
        var languages = langSvc.getSubLanguages(new Object());
        for (var i=0; i < languages.length; i++) {
            if (domLanguages.indexOf(languages[i]) >= 0) {
                found = languages[i];
                break;
            }
        }
        if (!found) {
            return null;
        }
    }
    return found;
}
