/* Copyright (c) 2010 ActiveState Software Inc.
   See the file LICENSE.txt for licensing information. */

/* Publishing API.
 *
 * Provides useful methods and functions relating to publishing.
 */

if (typeof(ko)=='undefined') {
    var ko = {};
}

if (typeof(ko.publishing)=='undefined') {
    ko.publishing = {};
} else {
    dump("WARNING: ko.publishing was already loaded - reloading it.\n");
}

(function() {

    //var _bundle = Components.classes["@mozilla.org/intl/stringbundle;1"]
    //    .getService(Components.interfaces.nsIStringBundleService)
    //    .createBundle("chrome://komodo/locale/views.properties");
    //var _observerSvc = Components.classes["@mozilla.org/observer-service;1"].
    //                getService(Components.interfaces.nsIObserverService);

    var _publishing_configs = null;
    var _gUpdateMenusRequired = true;

    this.getConfigurations = function ko_pub_getConfigurations()
    {
        if (_publishing_configs == null) {
            _publishing_configs = [];
            var prefs = Components.classes['@activestate.com/koPrefService;1'].
                            getService(Components.interfaces.koIPrefService).prefs;
            if (prefs.hasPref("publishing_configurations")) {
                /**
                 * @type {Components.interfaces.koIOrderedPreference}
                 */
                var pref_configs = prefs.getPref("publishing_configurations");
                var settings;
                for (var i=0; i < pref_configs.length; i++) {
                    settings = Components.classes["@activestate.com/koPublishingSettings;1"]
                                   .createInstance(Components.interfaces.koIPublishingSettings);
                    settings.unserializeFromPreference(pref_configs.getPref(i));
                    _publishing_configs.push(settings);
                }
            }
        }
        return _publishing_configs;
    };

    this.saveConfigurations = function ko_pub_saveConfigurations(configs)
    {
        var pref_configs = Components.classes['@activestate.com/koOrderedPreference;1'].
                        createInstance(Components.interfaces.koIOrderedPreference);
        for (var i=0; i < configs.length; i++) {
            pref_configs.appendPref(configs[i].serializeToPreference());
        }
        var prefs = Components.classes['@activestate.com/koPrefService;1'].
                        getService(Components.interfaces.koIPrefService).prefs;
        prefs.setPref("publishing_configurations", pref_configs);
        _publishing_configs = configs;
        _gUpdateMenusRequired = true;
    };

    this.newConfiguration = function ko_pub_newConfiguration()
    {
        var args = {
            "type": "new"
        };
        ko.windowManager.openDialog('chrome://publishing/content/publish-dialog.xul',
                                    '_blank',
                                    'chrome,titlebar,resizable=yes',
                                    args);
    };

    this.synchronize = function ko_pub_synchronize(id)
    {
        var settings = null;
        var configs = ko.publishing.getConfigurations();
        for (var i=0; i < configs.length; i++) {
            if (configs[i].id == id) {
                settings = configs[i];
                break;
            }
        }
        var args = {
            "type": "synchronize",
            "settings": settings
        };
        ko.windowManager.openDialog('chrome://publishing/content/publish-dialog.xul',
                                    '_blank',
                                    'chrome,titlebar,resizable=yes',
                                    args);
    };

    this.onMenuPopupShowing = function ko_pub_onMenuPopupShowing()
    {
        if (_gUpdateMenusRequired) {
            var menupopup = document.getElementById("tools_publishing_menupopup");
            var separator = document.getElementById("tools_publishing_newconfig_separator");
            var prevSibling;
            var menuitem = separator.previousSibling;
            // Remove any existing menu items added previously.
            while (menuitem) {
                prevSibling = menuitem.previousSibling;
                if (menuitem.hasAttribute("dynamically_added_menuitem")) {
                    menupopup.removeChild(menuitem);
                }
                menuitem = prevSibling;
            }
            var attributes;
            var configs = this.getConfigurations();
            for (var i=0; i < configs.length; i++) {
                attributes = {
                    "label": configs[i].name,
                    "oncommand": "ko.publishing.synchronize('" + configs[i].id + "')",
                    "dynamically_added_menuitem": "true"
                }
                menuitem = xtk.domutils.newElement("menuitem", attributes);
                menupopup.insertBefore(menuitem, separator);
            }
            _gUpdateMenusRequired = false;
        }
    };

}).apply(ko.publishing);
